#ifndef PCIE40_B2SLC_H
#define PCIE40_B2SLC_H
// Header file for B2 Slow control functions with PCIe40 

// Constants
// BAR number for Slow control interface
#define SLC_BAR 2
// Address of the register to reset the write FIFO and bit to use
#define SLC_WFIFO_RESET_ADD_0 0x00050560
#define SLC_WFIFO_RESET_ADD_1 0x00050580
#define SLC_WFIFO_RESET_BIT 0
#define SLC_RFIFO_RESET_ADD_0 0x000505a0
#define SLC_RFIFO_RESET_ADD_1 0x000505c0
#define SLC_RFIFO_RESET_BIT 0
#define SLC_WFIFO_START_ADD_0 0x00050480
#define SLC_WFIFO_START_ADD_1 0x000504a0
#define SLC_WFIFO_EMIT_BIT 0
#define SLC_WFIFO_ADD 0x00060000
#define SLC_RFIFO_STATUS 0x00060010
#define SLC_RFIFO_ADD 0x00060000

// Functions to read/write registers and stream files to Front End
#ifndef USE_PCIE40
extern "C" {
#endif 
int pcie40_readfee8(int dev, int ch, int adr);

int pcie40_writefee8(int dev, int ch, int adr, int val);

unsigned long pcie40_readfee32(int dev, int ch, int adr);

int pcie40_writefee32(int dev, int ch, int adr, int val);

int pcie40_writestream_klm(int dev, int ch, char *filename);
int pcie40_writestream_arich(int dev, int ch, char *filename);
int pcie40_writestream( int dev , int ch , char *filename , const char * detector ) ;

int pcie40_writebytestream(int dev, int ch, int len, const char *bytes);

#ifndef USE_PCIE40
}
#endif

#endif // PCIE40_B2SLC_H

